glibmm: Glib::Regex Class Reference

glibmm 2.66.4

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Glib::Regex Class Referencefinal

Perl-compatible regular expressions - matches strings against regular expressions. More...

`#include <glibmm/regex.h>`

## Public Member Functions
void | reference () const
| Increment the reference count for this object. More...
void | unreference () const
| Decrement the reference count for this object. More...
GRegex * | gobj ()
| Provides access to the underlying C instance. More...
const GRegex * | gobj () const
| Provides access to the underlying C instance. More...
GRegex * | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
| Regex ()=delete
| Regex (const Regex &)=delete
Regex & | operator= (const Regex &)=delete
Glib::ustring | get_pattern () const
| Gets the pattern string associated with regex, i.e. a copy of the string passed to g_regex_new(). More...
int | get_max_backref () const
| Returns the number of the highest back reference in the pattern, or 0 if the pattern does not contain back references. More...
int | get_capture_count () const
| Returns the number of capturing subpatterns in the pattern. More...
bool | get_has_cr_or_lf () const
| Checks whether the pattern contains explicit CR or LF references. More...
int | get_max_lookbehind () const
| Gets the number of characters in the longest lookbehind assertion in the pattern. More...
int | get_string_number (const Glib::ustring & name) const
| Retrieves the number of the subexpression named name. More...
RegexCompileFlags | get_compile_flags () const
| Returns the compile options that regex was created with. More...
RegexMatchFlags | get_match_flags () const
| Returns the match options that regex was created with. More...
bool | match (const Glib::ustring &string, Glib::MatchInfo & match_info, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| Scans for a match in string for the pattern in regex. More...
bool | match (const Glib::ustring &string, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| A match() method not requiring a Glib::MatchInfo. More...
bool | match (const Glib::ustring &string, int start_position, Glib::MatchInfo & match_info, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| A match() method with a start position and a Glib::MatchInfo. More...
bool | match (const Glib::ustring &string, gssize string_len, int start_position, Glib::MatchInfo & match_info, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| Scans for a match in string for the pattern in regex. More...
bool | match (const Glib::ustring &string, int start_position, RegexMatchFlags match_options)
| A match() method with a start position not requiring a Glib::MatchInfo. More...
bool | match (const Glib::ustring &string, gssize string_len, int start_position, RegexMatchFlags match_options)
| A match() method with a string length and start position not requiring a Glib::MatchInfo. More...
bool | match (Glib::ustring &&string,...)=delete
| Rvalue references, such as temporary values, are deprecated. More...
bool | match_all (const Glib::ustring &string, Glib::MatchInfo & match_info, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| Using the standard algorithm for regular expression matching only the longest match in the string is retrieved. More...
bool | match_all (const Glib::ustring &string, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| A match_all() method not requiring a Glib::MatchInfo. More...
bool | match_all (const Glib::ustring &string, int start_position, Glib::MatchInfo & match_info, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| A match_all() method with a start positon and a Glib::MatchInfo. More...
bool | match_all (const Glib::ustring &string, gssize string_len, int start_position, Glib::MatchInfo & match_info, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| Using the standard algorithm for regular expression matching only the longest match in the string is retrieved, it is not possible to obtain all the available matches. More...
bool | match_all (const Glib::ustring &string, int start_position, RegexMatchFlags match_options)
| A match_all() method with a start position not requiring a Glib::MatchInfo. More...
bool | match_all (const Glib::ustring &string, gssize string_len, int start_position, RegexMatchFlags match_options)
| A match_all() method with a start position and a string length not requiring a Glib::MatchInfo. More...
bool | match_all (Glib::ustring &&string,...)=delete
| Rvalue references, such as temporary values, are deprecated. More...
Glib::StringArrayHandle | split (const Glib::ustring &string, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| Breaks the string on the pattern, and returns an array of the tokens. More...
Glib::StringArrayHandle | split (const gchar *string, gssize string_len, int start_position, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0), int max_tokens=0) const
| Breaks the string on the pattern, and returns an array of the tokens. More...
Glib::StringArrayHandle | split (const Glib::ustring &string, int start_position, RegexMatchFlags match_options, int max_tokens) const
Glib::ustring | replace (const gchar *string, gssize string_len, int start_position, const Glib::ustring & replacement, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| Replaces all occurrences of the pattern in regex with the replacement text. More...
Glib::ustring | replace (const Glib::ustring &string, int start_position, const Glib::ustring & replacement, RegexMatchFlags match_options)
Glib::ustring | replace_literal (const gchar *string, gssize string_len, int start_position, const Glib::ustring & replacement, RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| Replaces all occurrences of the pattern in regex with the replacement text. More...
Glib::ustring | replace_literal (const Glib::ustring &string, int start_position, const Glib::ustring & replacement, RegexMatchFlags match_options)
Glib::ustring | replace_eval (const Glib::ustring &string, gssize string_len, int start_position, RegexMatchFlags match_options, GRegexEvalCallback eval, gpointer user_data)
| Replaces occurrences of the pattern in regex with the output of eval for that occurrence. More...

## Static Public Member Functions
static Glib::RefPtr< Glib::Regex > | create (const Glib::ustring & pattern, RegexCompileFlags compile_options=static_cast< RegexCompileFlags >(0), RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
static Glib::ustring | escape_string (const Glib::ustring &string)
static bool | match_simple (const Glib::ustring & pattern, const Glib::ustring &string, RegexCompileFlags compile_options=static_cast< RegexCompileFlags >(0), RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| Scans for a match in string for pattern. More...
static Glib::StringArrayHandle | split_simple (const Glib::ustring & pattern, const Glib::ustring &string, RegexCompileFlags compile_options=static_cast< RegexCompileFlags >(0), RegexMatchFlags match_options=static_cast< RegexMatchFlags >(0))
| Breaks the string on the pattern, and returns an array of the tokens. More...
static bool | check_replacement (const Glib::ustring & replacement, gboolean * has_references)
| Checks whether replacement is a valid replacement string (see g_regex_replace()), i.e. that all escape sequences in it are valid. More...

## Protected Member Functions
void | operator delete (void *, std::size_t)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Glib::Regex > | wrap (GRegex * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Perl-compatible regular expressions - matches strings against regular expressions.

The Glib::Regex functions implement regular expression pattern matching using syntax and semantics similar to Perl regular expression.

Some functions accept a start_position argument, setting it differs from just passing over a shortened string and setting REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion. For example, consider the pattern "\Biss\B" which finds occurrences of "iss" in the middle of words. ("\B" matches only if the current position in the subject is not a word boundary.) When applied to the string "Mississipi" from the fourth byte, namely "issipi", it does not match, because "\B" is always false at the start of the subject, which is deemed to be a word boundary. However, if the entire string is passed , but with start_position set to 4, it finds the second occurrence of "iss" because it is able to look behind the starting point to discover that it is preceded by a letter.

Note that, unless you set the REGEX_RAW flag, all the strings passed to these functions must be encoded in UTF-8. The lengths and the positions inside the strings are in bytes and not in characters, so, for instance, "\xc3\xa0" (i.e. "à") is two bytes long but it is treated as a single character. If you set REGEX_RAW the strings can be non-valid UTF-8 strings and a byte is treated as a character, so "\xc3\xa0" is two bytes and two characters long.

When matching a pattern, "\n" matches only against a "\n" character in the string, and "\r" matches only a "\r" character. To match any newline sequence use "\R". This particular group matches either the two-character sequence CR + LF ("\r\n"), or one of the single characters LF (linefeed, U+000A, "\n"), VT (vertical tab, U+000B, "\v"), FF (formfeed, U+000C, "\f"), CR (carriage return, U+000D, "\r"), NEL (next line, U+0085), LS (line separator, U+2028), or PS (paragraph separator, U+2029).

The behaviour of the dot, circumflex, and dollar metacharacters are affected by newline characters, the default is to recognize any newline character (the same characters recognized by "\R"). This can be changed with REGEX_NEWLINE_CR, REGEX_NEWLINE_LF and REGEX_NEWLINE_CRLF compile options, and with REGEX_MATCH_NEWLINE_ANY, REGEX_MATCH_NEWLINE_CR, REGEX_MATCH_NEWLINE_LF and REGEX_MATCH_NEWLINE_CRLF match options. These settings are also relevant when compiling a pattern if REGEX_EXTENDED is set, and an unescaped "#" outside a character class is encountered. This indicates a comment that lasts until after the next newline.

Creating and manipulating the same Glib::Regex class from different threads is not a problem as Glib::Regex does not modify its internal state between creation and destruction, on the other hand Glib::MatchInfo is not threadsafe.

The regular expressions low level functionalities are obtained through the excellent PCRE library written by Philip Hazel.

Note
  When you call a match() or a match_all() method taking a MatchInfo, use a Glib::ustring that still exists when you later call MatchInfo methods. If you call match() or match_all() with a std::string or a string literal, the method will internally use a temporary copy of the string. The copy will not exist when you call MatchInfo methods. The use of temporary string values is deprecated in all match() and match_all() methods since glibmm 2.64.
  Glib::ustring str1 = "String to search through";
  regex->match(str1, match_info);
  // ...
  if (match_info.matches()) // str1 must still exist here
  regex
  basic_regex< char > regex
  Glib::ustring
  Glib::ustring has much the same interface as std::string, but contains Unicode characters encoded as ...
  Definition: ustring.h:327

Since glibmm 2.14:

## Constructor & Destructor Documentation

## ◆ Regex() [1/2]

Glib::Regex::Regex | ( |  | ) |
| delete

## ◆ Regex() [2/2]

Glib::Regex::Regex | ( | const Regex & |  | ) |
| delete

## Member Function Documentation

## ◆ check_replacement()

static bool Glib::Regex::check_replacement | ( | const Glib::ustring & | replacement,
|  | gboolean * | has_references
| ) |  |
| static

Checks whether replacement is a valid replacement string (see g_regex_replace()), i.e. that all escape sequences in it are valid.

If has_references is not `nullptr` then replacement is checked for pattern references. For instance, replacement text 'foo\n' does not contain references and may be evaluated without information about actual match, but '\0\1' (whole match followed by first subpattern) requires valid MatchInfo object.

Since glibmm 2.14:

Parameters

  replacement | The replacement string.
  has_references | Location to store information about references in replacement or `nullptr`.

Returns
  Whether replacement is a valid replacement string.

Exceptions

  Glib::RegexError |

## ◆ create()

static Glib::RefPtr<Glib::Regex> Glib::Regex::create | ( | const Glib::ustring & | pattern,
|  | RegexCompileFlags | compile_options = `static_cast< RegexCompileFlags >(0)`,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |
| static

Exceptions

  Glib::RegexError |

## ◆ escape_string()

static Glib::ustring Glib::Regex::escape_string | ( | const Glib::ustring & | string | ) |
| static

## ◆ get_capture_count()

int Glib::Regex::get_capture_count | ( |  | ) | const

Returns the number of capturing subpatterns in the pattern.

Since glibmm 2.14:

Returns
  The number of capturing subpatterns.

## ◆ get_compile_flags()

RegexCompileFlags Glib::Regex::get_compile_flags | ( |  | ) | const

Returns the compile options that regex was created with.

Depending on the version of PCRE that is used, this may or may not include flags set by option expressions such as `(?i)` found at the top-level within the compiled pattern.

Since glibmm 2.26:

Returns
  Flags from RegexCompileFlags.

## ◆ get_has_cr_or_lf()

bool Glib::Regex::get_has_cr_or_lf | ( |  | ) | const

Checks whether the pattern contains explicit CR or LF references.

Since glibmm 2.34:

Returns
  `true` if the pattern contains explicit CR or LF references.

## ◆ get_match_flags()

RegexMatchFlags Glib::Regex::get_match_flags | ( |  | ) | const

Returns the match options that regex was created with.

Since glibmm 2.26:

Returns
  Flags from RegexMatchFlags.

## ◆ get_max_backref()

int Glib::Regex::get_max_backref | ( |  | ) | const

Returns the number of the highest back reference in the pattern, or 0 if the pattern does not contain back references.

Since glibmm 2.14:

Returns
  The number of the highest back reference.

## ◆ get_max_lookbehind()

int Glib::Regex::get_max_lookbehind | ( |  | ) | const

Gets the number of characters in the longest lookbehind assertion in the pattern.

This information is useful when doing multi-segment matching using the partial matching facilities.

Since glibmm 2.38:

Returns
  The number of characters in the longest lookbehind assertion.

## ◆ get_pattern()

Glib::ustring Glib::Regex::get_pattern | ( |  | ) | const

Gets the pattern string associated with regex, i.e. a copy of the string passed to g_regex_new().

Since glibmm 2.14:

Returns
  The pattern of regex.

## ◆ get_string_number()

int Glib::Regex::get_string_number | ( | const Glib::ustring & | name | ) | const

Retrieves the number of the subexpression named name.

Since glibmm 2.14:

Parameters

  name | Name of the subexpression.

Returns
  The number of the subexpression or -1 if name does not exists.

## ◆ gobj() [1/2]

GRegex* Glib::Regex::gobj | ( |  | ) |

Provides access to the underlying C instance.

## ◆ gobj() [2/2]

const GRegex* Glib::Regex::gobj | ( |  | ) | const

Provides access to the underlying C instance.

## ◆ gobj_copy()

GRegex* Glib::Regex::gobj_copy | ( |  | ) | const

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ match() [1/7]

bool Glib::Regex::match | ( | const Glib::ustring & | string,
|  | Glib::MatchInfo & | match_info,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

Scans for a match in string for the pattern in regex.

The match_options are combined with the match options specified when the regex structure was created, letting you have more flexibility in reusing Regex structures.

Unless REGEX_RAW is specified in the options, string must be valid UTF-8.

A MatchInfo structure, used to get information on the match, is stored in match_info if not `nullptr`. Note that if match_info is not `nullptr` then it is created even if the function returns `false`, i.e. you must free it regardless if regular expression actually matched.

To retrieve all the non-overlapping matches of the pattern in string you can use g_match_info_next().

[C example ellipted]

string is not copied and is used in MatchInfo internally. If you use any MatchInfo method (except g_match_info_free()) after freeing or modifying string then the behaviour is undefined.

Since glibmm 2.14:

Parameters

  string | The string to scan for matches.
  match_options | Match options.
  match_info | Pointer to location where to store the MatchInfo, or `nullptr` if you do not need it.

Returns
  `true` is the string matched, `false` otherwise.

## ◆ match() [2/7]

bool Glib::Regex::match | ( | const Glib::ustring & | string,
|  | gssize | string_len,
|  | int | start_position,
|  | Glib::MatchInfo & | match_info,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

Scans for a match in string for the pattern in regex.

The match_options are combined with the match options specified when the regex structure was created, letting you have more flexibility in reusing Regex structures.

Setting start_position differs from just passing over a shortened string and setting REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\\b".

Unless REGEX_RAW is specified in the options, string must be valid UTF-8.

A MatchInfo structure, used to get information on the match, is stored in match_info if not `nullptr`. Note that if match_info is not `nullptr` then it is created even if the function returns `false`, i.e. you must free it regardless if regular expression actually matched.

string is not copied and is used in MatchInfo internally. If you use any MatchInfo method (except g_match_info_free()) after freeing or modifying string then the behaviour is undefined.

To retrieve all the non-overlapping matches of the pattern in string you can use g_match_info_next().

[C example ellipted]

Since glibmm 2.14:

Parameters

  string | The string to scan for matches.
  string_len | The length of string, in bytes, or -1 if string is nul-terminated.
  start_position | Starting index of the string to match, in bytes.
  match_options | Match options.
  match_info | Pointer to location where to store the MatchInfo, or `nullptr` if you do not need it.

Returns
  `true` is the string matched, `false` otherwise.

Exceptions

  Glib::RegexError |

## ◆ match() [3/7]

bool Glib::Regex::match | ( | const Glib::ustring & | string,
|  | gssize | string_len,
|  | int | start_position,
|  | RegexMatchFlags | match_options
| ) |  |

A match() method with a string length and start position not requiring a Glib::MatchInfo.

## ◆ match() [4/7]

bool Glib::Regex::match | ( | const Glib::ustring & | string,
|  | int | start_position,
|  | Glib::MatchInfo & | match_info,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

A match() method with a start position and a Glib::MatchInfo.

Exceptions

  Glib::RegexError |

## ◆ match() [5/7]

bool Glib::Regex::match | ( | const Glib::ustring & | string,
|  | int | start_position,
|  | RegexMatchFlags | match_options
| ) |  |

A match() method with a start position not requiring a Glib::MatchInfo.

Exceptions

  Glib::RegexError |

## ◆ match() [6/7]

bool Glib::Regex::match | ( | const Glib::ustring & | string,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

A match() method not requiring a Glib::MatchInfo.

## ◆ match() [7/7]

bool Glib::Regex::match | ( | Glib::ustring && | string,
|  |  | ...
| ) |  |
| delete

Rvalue references, such as temporary values, are deprecated.

This declaration is enabled if the preprocessor constant GLIBMM_DISABLE_DEPRECATED is defined.

## ◆ match_all() [1/7]

bool Glib::Regex::match_all | ( | const Glib::ustring & | string,
|  | Glib::MatchInfo & | match_info,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

Using the standard algorithm for regular expression matching only the longest match in the string is retrieved.

This function uses a different algorithm so it can retrieve all the possible matches. For more documentation see g_regex_match_all_full().

A MatchInfo structure, used to get information on the match, is stored in match_info if not `nullptr`. Note that if match_info is not `nullptr` then it is created even if the function returns `false`, i.e. you must free it regardless if regular expression actually matched.

string is not copied and is used in MatchInfo internally. If you use any MatchInfo method (except g_match_info_free()) after freeing or modifying string then the behaviour is undefined.

Since glibmm 2.14:

Parameters

  string | The string to scan for matches.
  match_options | Match options.
  match_info | Pointer to location where to store the MatchInfo, or `nullptr` if you do not need it.

Returns
  `true` is the string matched, `false` otherwise.

## ◆ match_all() [2/7]

bool Glib::Regex::match_all | ( | const Glib::ustring & | string,
|  | gssize | string_len,
|  | int | start_position,
|  | Glib::MatchInfo & | match_info,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

Using the standard algorithm for regular expression matching only the longest match in the string is retrieved, it is not possible to obtain all the available matches.

For instance matching "<a> <b> <c>" against the pattern "<.*>" you get "<a> <b> <c>".

This function uses a different algorithm (called DFA, i.e. deterministic finite automaton), so it can retrieve all the possible matches, all starting at the same point in the string. For instance matching "<a> <b> <c>" against the pattern "<.*>;" you would obtain three matches: "<a> <b> <c>", "<a> <b>" and "<a>".

The number of matched strings is retrieved using g_match_info_get_match_count(). To obtain the matched strings and their position you can use, respectively, g_match_info_fetch() and g_match_info_fetch_pos(). Note that the strings are returned in reverse order of length; that is, the longest matching string is given first.

Note that the DFA algorithm is slower than the standard one and it is not able to capture substrings, so backreferences do not work.

Setting start_position differs from just passing over a shortened string and setting REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\\b".

Unless REGEX_RAW is specified in the options, string must be valid UTF-8.

A MatchInfo structure, used to get information on the match, is stored in match_info if not `nullptr`. Note that if match_info is not `nullptr` then it is created even if the function returns `false`, i.e. you must free it regardless if regular expression actually matched.

string is not copied and is used in MatchInfo internally. If you use any MatchInfo method (except g_match_info_free()) after freeing or modifying string then the behaviour is undefined.

Since glibmm 2.14:

Parameters

  string | The string to scan for matches.
  string_len | The length of string, in bytes, or -1 if string is nul-terminated.
  start_position | Starting index of the string to match, in bytes.
  match_options | Match options.
  match_info | Pointer to location where to store the MatchInfo, or `nullptr` if you do not need it.

Returns
  `true` is the string matched, `false` otherwise.

Exceptions

  Glib::RegexError |

## ◆ match_all() [3/7]

bool Glib::Regex::match_all | ( | const Glib::ustring & | string,
|  | gssize | string_len,
|  | int | start_position,
|  | RegexMatchFlags | match_options
| ) |  |

A match_all() method with a start position and a string length not requiring a Glib::MatchInfo.

Exceptions

  Glib::RegexError |

## ◆ match_all() [4/7]

bool Glib::Regex::match_all | ( | const Glib::ustring & | string,
|  | int | start_position,
|  | Glib::MatchInfo & | match_info,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

A match_all() method with a start positon and a Glib::MatchInfo.

Exceptions

  Glib::RegexError |

## ◆ match_all() [5/7]

bool Glib::Regex::match_all | ( | const Glib::ustring & | string,
|  | int | start_position,
|  | RegexMatchFlags | match_options
| ) |  |

A match_all() method with a start position not requiring a Glib::MatchInfo.

Exceptions

  Glib::RegexError |

## ◆ match_all() [6/7]

bool Glib::Regex::match_all | ( | const Glib::ustring & | string,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

A match_all() method not requiring a Glib::MatchInfo.

## ◆ match_all() [7/7]

bool Glib::Regex::match_all | ( | Glib::ustring && | string,
|  |  | ...
| ) |  |
| delete

Rvalue references, such as temporary values, are deprecated.

This declaration is enabled if the preprocessor constant GLIBMM_DISABLE_DEPRECATED is defined.

## ◆ match_simple()

static bool Glib::Regex::match_simple | ( | const Glib::ustring & | pattern,
|  | const Glib::ustring & | string,
|  | RegexCompileFlags | compile_options = `static_cast< RegexCompileFlags >(0)`,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |
| static

Scans for a match in string for pattern.

This function is equivalent to g_regex_match() but it does not require to compile the pattern with g_regex_new(), avoiding some lines of code when you need just to do a match without extracting substrings, capture counts, and so on.

If this function is to be called on the same pattern more than once, it's more efficient to compile the pattern once with g_regex_new() and then use g_regex_match().

Since glibmm 2.14:

Parameters

  pattern | The regular expression.
  string | The string to scan for matches.
  compile_options | Compile options for the regular expression, or 0.
  match_options | Match options, or 0.

Returns
  `true` if the string matched, `false` otherwise.

## ◆ operator delete()

void Glib::Regex::operator delete | ( | void * | ,
|  | std::size_t |
| ) |  |
| protected

## ◆ operator=()

Regex& Glib::Regex::operator= | ( | const Regex & |  | ) |
| delete

## ◆ reference()

void Glib::Regex::reference | ( |  | ) | const

Increment the reference count for this object.

You should never need to do this manually - use the object via a RefPtr instead.

## ◆ replace() [1/2]

Glib::ustring Glib::Regex::replace | ( | const gchar * | string,
|  | gssize | string_len,
|  | int | start_position,
|  | const Glib::ustring & | replacement,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

Replaces all occurrences of the pattern in regex with the replacement text.

Backreferences of the form '\number' or '\g<number>' in the replacement text are interpolated by the number-th captured subexpression of the match, '\g<name>' refers to the captured subexpression with the given name. '\0' refers to the complete match, but '\0' followed by a number is the octal representation of a character. To include a literal '\' in the replacement, write '\\\\'.

There are also escapes that changes the case of the following text:

- \l: Convert to lower case the next character
- \u: Convert to upper case the next character
- \L: Convert to lower case till \E
- \U: Convert to upper case till \E
- \E: End case modification

If you do not need to use backreferences use g_regex_replace_literal().

The replacement string must be UTF-8 encoded even if REGEX_RAW was passed to g_regex_new(). If you want to use not UTF-8 encoded strings you can use g_regex_replace_literal().

Setting start_position differs from just passing over a shortened string and setting REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\\b".

Since glibmm 2.14:

Parameters

  string | The string to perform matches against.
  string_len | The length of string, in bytes, or -1 if string is nul-terminated.
  start_position | Starting index of the string to match, in bytes.
  replacement | Text to replace each match with.
  match_options | Options for the match.

Returns
  A newly allocated string containing the replacements.

Exceptions

  Glib::RegexError |

## ◆ replace() [2/2]

Glib::ustring Glib::Regex::replace | ( | const Glib::ustring & | string,
|  | int | start_position,
|  | const Glib::ustring & | replacement,
|  | RegexMatchFlags | match_options
| ) |  |

Exceptions

  Glib::RegexError |

## ◆ replace_eval()

Glib::ustring Glib::Regex::replace_eval | ( | const Glib::ustring & | string,
|  | gssize | string_len,
|  | int | start_position,
|  | RegexMatchFlags | match_options,
|  | GRegexEvalCallback | eval,
|  | gpointer | user_data
| ) |  |

Replaces occurrences of the pattern in regex with the output of eval for that occurrence.

Setting start_position differs from just passing over a shortened string and setting REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\\b".

The following example uses g_regex_replace_eval() to replace multiple strings at once:

[C example ellipted]

Since glibmm 2.14:

Parameters

  string | String to perform matches against.
  string_len | The length of string, in bytes, or -1 if string is nul-terminated.
  start_position | Starting index of the string to match, in bytes.
  match_options | Options for the match.
  eval | A function to call for each match.
  user_data | User data to pass to the function.

Returns
  A newly allocated string containing the replacements.

Exceptions

  Glib::RegexError |

## ◆ replace_literal() [1/2]

Glib::ustring Glib::Regex::replace_literal | ( | const gchar * | string,
|  | gssize | string_len,
|  | int | start_position,
|  | const Glib::ustring & | replacement,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

Replaces all occurrences of the pattern in regex with the replacement text.

replacement is replaced literally, to include backreferences use g_regex_replace().

Setting start_position differs from just passing over a shortened string and setting REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\\b".

Since glibmm 2.14:

Parameters

  string | The string to perform matches against.
  string_len | The length of string, in bytes, or -1 if string is nul-terminated.
  start_position | Starting index of the string to match, in bytes.
  replacement | Text to replace each match with.
  match_options | Options for the match.

Returns
  A newly allocated string containing the replacements.

Exceptions

  Glib::RegexError |

## ◆ replace_literal() [2/2]

Glib::ustring Glib::Regex::replace_literal | ( | const Glib::ustring & | string,
|  | int | start_position,
|  | const Glib::ustring & | replacement,
|  | RegexMatchFlags | match_options
| ) |  |

Exceptions

  Glib::RegexError |

## ◆ split() [1/3]

Glib::StringArrayHandle Glib::Regex::split | ( | const gchar * | string,
|  | gssize | string_len,
|  | int | start_position,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`,
|  | int | max_tokens = `0`
| ) |  | const

Breaks the string on the pattern, and returns an array of the tokens.

If the pattern contains capturing parentheses, then the text for each of the substrings will also be returned. If the pattern does not match anywhere in the string, then the whole string is returned as the first token.

As a special case, the result of splitting the empty string "" is an empty vector, not a vector containing a single string. The reason for this special case is that being able to represent an empty vector is typically more useful than consistent handling of empty elements. If you do need to represent empty elements, you'll need to check for the empty string before calling this function.

A pattern that can match empty strings splits string into separate characters wherever it matches the empty string between characters. For example splitting "ab c" using as a separator "\\s*", you will get "a", "b" and "c".

Setting start_position differs from just passing over a shortened string and setting REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\\b".

Since glibmm 2.14:

Parameters

  string | The string to split with the pattern.
  string_len | The length of string, in bytes, or -1 if string is nul-terminated.
  start_position | Starting index of the string to match, in bytes.
  match_options | Match time option flags.
  max_tokens | The maximum number of tokens to split string into. If this is less than 1, the string is split completely.

Returns
  A `nullptr`-terminated gchar ** array.

Exceptions

  Glib::RegexError |

## ◆ split() [2/3]

Glib::StringArrayHandle Glib::Regex::split | ( | const Glib::ustring & | string,
|  | int | start_position,
|  | RegexMatchFlags | match_options,
|  | int | max_tokens
| ) |  | const

Exceptions

  Glib::RegexError |

## ◆ split() [3/3]

Glib::StringArrayHandle Glib::Regex::split | ( | const Glib::ustring & | string,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |

Breaks the string on the pattern, and returns an array of the tokens.

If the pattern contains capturing parentheses, then the text for each of the substrings will also be returned. If the pattern does not match anywhere in the string, then the whole string is returned as the first token.

As a special case, the result of splitting the empty string "" is an empty vector, not a vector containing a single string. The reason for this special case is that being able to represent an empty vector is typically more useful than consistent handling of empty elements. If you do need to represent empty elements, you'll need to check for the empty string before calling this function.

A pattern that can match empty strings splits string into separate characters wherever it matches the empty string between characters. For example splitting "ab c" using as a separator "\\s*", you will get "a", "b" and "c".

Since glibmm 2.14:

Parameters

  string | The string to split with the pattern.
  match_options | Match time option flags.

Returns
  A `nullptr`-terminated gchar ** array.

## ◆ split_simple()

static Glib::StringArrayHandle Glib::Regex::split_simple | ( | const Glib::ustring & | pattern,
|  | const Glib::ustring & | string,
|  | RegexCompileFlags | compile_options = `static_cast< RegexCompileFlags >(0)`,
|  | RegexMatchFlags | match_options = `static_cast< RegexMatchFlags >(0)`
| ) |  |
| static

Breaks the string on the pattern, and returns an array of the tokens.

If the pattern contains capturing parentheses, then the text for each of the substrings will also be returned. If the pattern does not match anywhere in the string, then the whole string is returned as the first token.

This function is equivalent to g_regex_split() but it does not require to compile the pattern with g_regex_new(), avoiding some lines of code when you need just to do a split without extracting substrings, capture counts, and so on.

If this function is to be called on the same pattern more than once, it's more efficient to compile the pattern once with g_regex_new() and then use g_regex_split().

As a special case, the result of splitting the empty string "" is an empty vector, not a vector containing a single string. The reason for this special case is that being able to represent an empty vector is typically more useful than consistent handling of empty elements. If you do need to represent empty elements, you'll need to check for the empty string before calling this function.

A pattern that can match empty strings splits string into separate characters wherever it matches the empty string between characters. For example splitting "ab c" using as a separator "\\s*", you will get "a", "b" and "c".

Since glibmm 2.14:

Parameters

  pattern | The regular expression.
  string | The string to scan for matches.
  compile_options | Compile options for the regular expression, or 0.
  match_options | Match options, or 0.

Returns
  A `nullptr`-terminated array of strings.

## ◆ unreference()

void Glib::Regex::unreference | ( |  | ) | const

Decrement the reference count for this object.

You should never need to do this manually - use the object via a RefPtr instead.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Glib::Regex > wrap | ( | GRegex * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.